## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without check

%bcond bundled_rust_deps %{defined:rhel}

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           loupe
Version:        48.0
Release:        %autorelease
Summary:        Image viewer

# loupe: GPL-3.0-or-later
# Rust dependencies:
# (MIT OR Apache-2.0) AND Unicode-3.0
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause OR Apache-2.0 OR MIT
# GPL-3.0-or-later
# ISC
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# MPL-2.0 OR LGPL-2.1-or-later
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        %{shrink:
    GPL-3.0-or-later AND
    ISC AND
    MIT AND
    Unicode-3.0 AND
    Unicode-DFS-2016 AND
    (Apache-2.0 OR MIT) AND
    (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND
    (BSD-2-Clause OR Apache-2.0 OR MIT) AND
    (MIT OR Apache-2.0 OR Zlib) AND
    (MPL-2.0 OR LGPL-2.1-or-later) AND
    (Unlicense OR MIT)
}
# LICENSE.dependencies contains a full license breakdown
URL:            https://gitlab.gnome.org/GNOME/loupe
Source0:        https://download.gnome.org/sources/loupe/48/loupe-%{tarball_version}.tar.xz
# To create the vendor tarball:
#   tar Jxvf loupe-%%{tarball_version}.tar.xz ; \
#   pushd loupe-%%{tarball_version} ; \
#   cargo vendor --versioned-dirs ; \
#   tar Jcvf ../loupe-%%{tarball_version}-vendor.tar.xz vendor/ ; \
#   popd
Source1:        loupe-%{tarball_version}-vendor.tar.xz

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

%if 0%{?rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros
%endif
BuildRequires:  itstool
BuildRequires:  meson
%if %{with bundled_rust_deps}
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(gweather4)
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libadwaita-1)
BuildRequires:  pkgconfig(libseccomp)
%endif
BuildRequires:  /usr/bin/appstream-util
BuildRequires:  /usr/bin/desktop-file-validate

# For /usr/share/dbus-1/services directory
Requires:       dbus
# Image loaders used by loupe
Requires:       glycin-loaders >= 1.1
# For hicolor icon theme directories
Requires:       hicolor-icon-theme

%description
An image viewer application written with GTK 4, Libadwaita and Rust.

Features:

- Fast GPU accelerated image rendering with tiled rendering for SVGs
- Extendable and sandboxed (expect SVG) image decoding
- Support for more than 15 image formats by default
- Extensive support for touchpad and touchscreen gestures
- Accessible presentation of the most important metadata
- Sleek but powerful interface developed in conjunction with GNOME Human
  Interface Guidelines


%prep
%if %{with bundled_rust_deps}
%autosetup -n loupe-%{tarball_version} -p1 -a1
%cargo_prep -v vendor
%else
%autosetup -n loupe-%{tarball_version} -p1
%cargo_prep
sed -i -e '/Cargo.lock/d' meson.build
%endif


%if %{without bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires -f x11
%endif


%build
%meson
%meson_build

%cargo_license_summary
%{cargo_license} > LICENSE.dependencies
%if %{with bundled_rust_deps}
%cargo_vendor_manifest
%endif


%install
%meson_install

%find_lang loupe --with-gnome


%if %{with check}
%check
%meson_test

appstream-util validate-relax --nonet $RPM_BUILD_ROOT%{_metainfodir}/org.gnome.Loupe.metainfo.xml
desktop-file-validate $RPM_BUILD_ROOT%{_datadir}/applications/org.gnome.Loupe.desktop
%endif


%files -f loupe.lang
%license COPYING.md
%license LICENSE.dependencies
%if %{with bundled_rust_deps}
%license cargo-vendor.txt
%endif
%doc NEWS README.md
%{_bindir}/loupe
%{_datadir}/applications/org.gnome.Loupe.desktop
%{_datadir}/dbus-1/services/org.gnome.Loupe.service
%{_datadir}/glib-2.0/schemas/org.gnome.Loupe.gschema.xml
%{_datadir}/icons/hicolor/scalable/apps/org.gnome.Loupe*.svg
%{_datadir}/icons/hicolor/symbolic/apps/org.gnome.Loupe-symbolic.svg
%{_metainfodir}/org.gnome.Loupe.metainfo.xml


%changelog
## START: Generated by rpmautospec
* Mon Mar 24 2025 Fabio Valentini <decathorpe@gmail.com> - 48.0-1
- Update to version 48.0; Fixes RHBZ#2336275

* Thu Jan 23 2025 nmontero <nmontero@redhat.com> - 47.4-1
- Update to 47.4

* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 47.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Sun Dec 01 2024 Fabio Valentini <decathorpe@gmail.com> - 47.2-1
- Update to version 47.2; Fixes RHBZ#2328441

* Sun Dec 01 2024 Fabio Valentini <decathorpe@gmail.com> - 47.1-3
- Simplify macro usage for conditionally building with vendored deps

* Mon Nov 11 2024 Adam Williamson <awilliam@redhat.com> - 47.1-2
- Backport MR #465 to fix crash with GTK 4.17

* Thu Oct 17 2024 nmontero <nmontero@redhat.com> - 47.1-1
- Update to 47.1

* Mon Sep 30 2024 Fabio Valentini <decathorpe@gmail.com> - 47.0-1
- Update to version 47.0; Fixes RHBZ#2295529

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 46.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri May 24 2024 Fabio Valentini <decathorpe@gmail.com> - 46.2-2
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Sun Apr 14 2024 Fabio Valentini <decathorpe@gmail.com> - 46.2-1
- Update to 46.2

* Sun Apr 07 2024 David King <amigadave@amigadave.com> - 46.1-1
- Update to 46.1

* Fri Apr 05 2024 Fabio Valentini <decathorpe@gmail.com> - 46.0-2
- Revert to de-vendoring dependencies on Fedora

* Wed Mar 27 2024 David King <amigadave@amigadave.com> - 46.0-1
- Update to 46.0

* Thu Feb 01 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 45.3-4
- Update Rust macro usage

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 45.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 45.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Dec 15 2023 Kalev Lember <klember@redhat.com> - 45.3-1
- Update to 45.3

* Wed Nov 29 2023 Kalev Lember <klember@redhat.com> - 45.2-1
- Update to 45.2

* Wed Nov 15 2023 Kalev Lember <klember@redhat.com> - 45.1-2
- Update license tag for dependencies

* Wed Nov 15 2023 Kalev Lember <klember@redhat.com> - 45.1-1
- Update to 45.1

* Tue Nov 14 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 45.0-4
- Fix RHEL build

* Thu Sep 28 2023 Kalev Lember <klember@redhat.com> - 45.0-3
- Backport upstream MR #302 to fix printing

* Wed Sep 27 2023 Kalev Lember <klember@redhat.com> - 45.0-2
- Backport upstream MR #299 to enable sandboxing

* Tue Sep 19 2023 Kalev Lember <klember@redhat.com> - 45.0-1
- Update to 45.0

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-6
- ExcludeArch i686 for
  https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-5
- Use bundled rust deps on RHEL

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-4
- Buildrequire cargo-rpm-macros instead of rust-packaging

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-3
- Add check bcond to ensure cargo_buildrequires does the right thing

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-2
- Require dbus and hicolor-icon-theme for directory ownership

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 45~beta.1-1
- Initial Fedora packaging (rhbz#2233324)
## END: Generated by rpmautospec
